#ifndef AFF_SIGNE_H
#define AFF_SIGNE_H

/*
 * SESH_fix_dims -- 
 *	computes the dimensions of a Text item (its width
 * 	and its height).  If the dimensions are already known, this
 * 	function is NO-OP, so it can be called safely.  
 */

void
SESH_fix_dims(TKSESH_output *where, TKSTexteGeometry *geom, Texte *t);

/*
 * SESH_fix_dims -- 
 * 	Returns the width of a text item
 */

double
SESH_texte_width(TKSESH_output *where, TKSTexteGeometry *geom, Texte *t);

/*
 * SESH_texte_width --
 * 	Returns the height of a text item
 */

double
SESH_texte_height(TKSESH_output *where, TKSTexteGeometry *geom, Texte *t);

/*
 * SESH_aff_texte --
 * 	Displays a text item on *where*
 */

void 
SESH_aff_texte(TKSESH_output *where, TKSTexteGeometry *geom,
	       double *x, double *y,
	       Texte *t);

#endif

