#ifndef BFAUX_H
#define BFAUX_H 

/*
  Low level manipulation function for Bzr fonts
  and chars
*/
#include "general.h"
#include "tgraph.h"

PUBLIC void 
BZR_delete(BFont *f);

PUBLIC BFont *
BZR_new_font();

/* VERY LOW LEVEL FUNCTION */

PUBLIC void 
BZR_fixe_trace(TKSESH_point depart, 
							 TKSESH_point c1, 
							 TKSESH_point c2,
							 TKSESH_point dernier,
							 Chaine s);
PUBLIC void 
BZR_delete_contour(Contour *c);

PUBLIC void 
BZR_delete_lettre(Lettre *l);



#endif
/* Let's preserve the present presentation
 * Local Variables:
 * tab-width: 2
 * c-block-comments-indent-p: nil
 * End:
 */
