/**
 * PRIVATE DEFINITIONS for text Manipulation
 *
 */

typedef int coordsvect[10];

typedef struct _SignePix {
	Listesignes *l;
} SignePix;

typedef struct _GeneralIndex {
	struct _Texte * t;											/* the Texte item */
	int s;												/* number of sign in text */
	SignePix signe ;											/* pointer to the said sign */
} GeneralIndex;

typedef struct {
	coordsvect coords;
	char *descr;
} text_coords;

/* marques */
typedef struct _Marque {
	char * nom;
	/* struct _Texte  * texte;*/
	struct _GeneralIndex index;
	struct _Marque * next, *previous;	/* liste globale des marques */
} Marque;

typedef struct _Liste_marques {
	Marque *m;
	struct _Liste_marques * next, *previous; /* liste des marques par unite de texte*/
} Liste_marques;
	 
typedef struct _Texte {
	/*
	 * 
	 * ATTENTION !!!!!!!!!!!!!!!
	 * trs important !!!!!!!!!!
	 * 
	 * un T_NL appartient  la ligne QUI LE SUIT
	 *
	 */
	
	enum { T_TEXTE, 
					 T_NL, T_NP,
					 T_FIXE_COORDONNEES,
					 T_LIGNE_COMMENTAIRE
			 } type;
	
	enum _etat { E_NOUVEAU, E_AFFICHE, E_CACHE, E_PARTIEL} etat;
	int real_dims;								/* have dimensions be computed ? */
	TKSO_state couleur;
  Quadra * q;
	double x, y;									/* lower left corner */
	double oldx, oldy;						/* previous values */
	double scaleh;									/* drawing scale when in lines*/
	double scalev;									/* drawing scale when in columns */
  double wh, hh;										/* width, height when in lines*/
  double wv, hv;										/* width, height when in columns */
	int saut;											/* pour les lignes et les pages */
	char * texte;									/* pour les lignes de commentaire */
	text_coords coordonnees;			/* pour fixer les coordonnes dans le texte */
	int first;										/* are we the first text item  ? */
	unsigned long int compteur;		/* quand le quadra a-t-il t affich ? */
	Liste_marques * liste_des_marques;
	/* SESH_tags * liste_des_tags;*/
  struct _Texte * next, *previous;
	Listesignes * lessignes;
	/*** TEMPORARY WORK AROUND. MORE GENERAL SYSTEM SHOULD FOLLOW : */
	int selected;
} Texte;

/*
 * Local Variables:
 * tab-width: 2
 * c-block-comments-indent-p: nil
 * End:
 */
