/* A Bison parser, made from ./sesh.y
   by GNU bison 1.35.  */

#define YYBISON 1  /* Identify Bison output.  */

#define yyparse seshparse
#define yylex seshlex
#define yyerror sesherror
#define yylval seshlval
#define yychar seshchar
#define yydebug seshdebug
#define yynerrs seshnerrs
# define	TEXTE	257
# define	DEBUTHIEROGS	258
# define	FINHIEROGS	259
# define	HIEROGLYPHE	260
# define	INCONNU	261
# define	POINT	262
# define	POINTPOINT	263
# define	KERNING	264
# define	DEBUTCONSTRUCTION	265
# define	CARTF	266
# define	DIEZE	267
# define	ROMAIN	268
# define	GAUCHEDROITE	269
# define	DROITEGAUCHE	270
# define	LEFTRIGHT	271
# define	RIGHTLEFT	272
# define	INTERNALSPACE	273
# define	HACHUREG	274
# define	HACHUREV	275
# define	HACHUREH	276
# define	HACHURET	277
# define	HACHURES	278
# define	OVERWRITE	279
# define	SIZE	280
# define	ROTATION	281
# define	NROTATION	282
# define	REVERT	283
# define	IGNORE	284
# define	LONGSIGN	285
# define	WIDECADRAT	286
# define	TEXTESUPER	287
# define	POINTROUGE	288
# define	POINTNOIR	289
# define	RED	290
# define	BLACK	291
# define	HAPLOGRAPHIE	292
# define	LACUNE	293
# define	LIGNELACUNE	294
# define	DSTSUPERFETATOIRE	295
# define	FSTSUPERFETATOIRE	296
# define	DSTEFFACE	297
# define	FSTEFFACE	298
# define	DSTDISPARU	299
# define	FSTDISPARU	300
# define	DSTRAJOUTSCRIBE	301
# define	FSTRAJOUTSCRIBE	302
# define	DSTRAJOUTAUTEUR	303
# define	FSTRAJOUTAUTEUR	304
# define	SEPARATEUR	305
# define	FINMOT	306
# define	GRAMMAIRE	307
# define	FIN_LIGNE	308
# define	FIN_PAGE	309
# define	SAUT_LIGNES	310
# define	SAUT_PAGES	311
# define	FIXE_LIGNE	312
# define	LIGNE_COMMENTAIRE	313

#line 5 "./sesh.y"


#define _POSIX_SOURCE 1

#include <malloc.h>
#include "general.h"
#include "quadra.h"
#include "mdctexte.h"
#include "mdccoord.h"
#include "seshaux.h"
#include "getlig.h"

char rapport_erreur_de_syntaxe[1024];
int  erreur_de_syntaxe;

static int color= 0;
static int ingray= FALSE;

extern int 
seshlex();

void 
yyerror(char *s);

#include <stdio.h>
#ifndef NULL
#define NULL 0
#endif

#ifndef TRUE
#define TRUE 1
#define FALSE 0
#endif

Texte *resultat;


#line 43 "./sesh.y"
#ifndef YYSTYPE
typedef union {
	Texte *un_texte;
	struct texte_liste {
		Texte * texte;
		Texte * last;
	} une_texte_liste;
	Quadra * un_quadra;
	Vertlist* une_vertlist;
	union _Donnees une_donnee;
	Signe un_signe;
	int un_entier;
	char * une_chaine;
	text_coords des_coordonnees;
	Typehachure une_hachure;			/* ancien systme */
	Hachures des_hachures;
	Typegroupe un_typegroupe;
	Typeseparateur un_separateur;
	struct _Signinlig *ligature;
	struct _Signe *signe;
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
#ifndef YYDEBUG
# define YYDEBUG 0
#endif



#define	YYFINAL		119
#define	YYFLAG		-32768
#define	YYNTBASE	67

/* YYTRANSLATE(YYLEX) -- Bison token number corresponding to YYLEX. */
#define YYTRANSLATE(x) ((unsigned)(x) <= 313 ? yytranslate[x] : 97)

/* YYTRANSLATE[YYLEX] -- Bison token number corresponding to YYLEX. */
static const char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    62,     2,
      65,    66,    61,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    60,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    63,     2,    64,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59
};

#if YYDEBUG
static const short yyprhs[] =
{
       0,     0,     4,     6,     8,    10,    13,    15,    19,    22,
      25,    26,    29,    31,    33,    35,    38,    40,    42,    44,
      46,    48,    49,    54,    57,    59,    62,    63,    65,    67,
      69,    71,    73,    75,    77,    79,    81,    83,    85,    91,
      92,    95,    97,   103,   105,   107,   111,   116,   120,   122,
     126,   127,   130,   132,   136,   138,   142,   144,   146,   148,
     150,   152,   154,   160,   162,   164,   166,   168,   170,   171,
     173,   174,   175,   178,   180,   182,   184,   186,   188,   190,
     194,   198,   202,   206
};
static const short yyrhs[] =
{
      68,    69,    71,     0,    71,     0,     1,     0,    71,     0,
      52,    71,     0,    70,     0,    69,    71,    70,     0,    87,
      74,     0,    79,    72,     0,     0,    72,    73,     0,    13,
       0,    36,     0,    37,     0,    80,    75,     0,    55,     0,
      54,     0,    58,     0,    59,     0,    24,     0,     0,    71,
      87,    80,    75,     0,    78,    71,     0,    76,     0,    78,
      76,     0,     0,    51,     0,    82,     0,    81,     0,    14,
       0,    38,     0,    15,     0,    16,     0,    39,     0,    40,
       0,    33,     0,    84,     0,    82,    60,    83,    87,    84,
       0,     0,    63,    64,     0,    85,     0,    85,    61,    83,
      87,    86,     0,    86,     0,    88,     0,    88,    62,    89,
       0,    11,    77,    12,    83,     0,    18,    77,    17,     0,
      96,     0,    65,    77,    66,     0,     0,    87,    10,     0,
      91,     0,    91,    25,    91,     0,    88,     0,    88,    62,
      89,     0,     6,     0,     8,     0,     9,     0,    34,     0,
      35,     0,     7,     0,    92,    90,    94,    83,    93,     0,
      20,     0,    22,     0,    21,     0,    23,     0,    53,     0,
       0,    52,     0,     0,     0,    95,    94,     0,    26,     0,
      27,     0,    28,     0,    29,     0,    30,     0,    31,     0,
      41,    77,    42,     0,    43,    77,    44,     0,    45,    77,
      46,     0,    47,    77,    48,     0,    49,    77,    50,     0
};

#endif

#if YYDEBUG
/* YYRLINE[YYN] -- source line where rule number YYN was defined. */
static const short yyrline[] =
{
       0,   126,   129,   130,   134,   135,   138,   144,   153,   164,
     167,   169,   172,   177,   181,   188,   195,   201,   207,   213,
     221,   223,   226,   237,   243,   247,   256,   258,   261,   281,
     288,   293,   297,   301,   305,   309,   313,   320,   325,   342,
     343,   346,   348,   357,   363,   369,   381,   387,   393,   394,
     401,   405,   411,   412,   420,   428,   438,   443,   447,   451,
     456,   461,   468,   473,   478,   482,   486,   492,   493,   496,
     497,   500,   501,   504,   506,   507,   508,   510,   511,   514,
     521,   527,   533,   539
};
#endif


#if (YYDEBUG) || defined YYERROR_VERBOSE

/* YYTNAME[TOKEN_NUM] -- String name of the token TOKEN_NUM. */
static const char *const yytname[] =
{
  "$", "error", "$undefined.", "TEXTE", "DEBUTHIEROGS", "FINHIEROGS", 
  "HIEROGLYPHE", "INCONNU", "POINT", "POINTPOINT", "KERNING", 
  "DEBUTCONSTRUCTION", "CARTF", "DIEZE", "ROMAIN", "GAUCHEDROITE", 
  "DROITEGAUCHE", "LEFTRIGHT", "RIGHTLEFT", "INTERNALSPACE", "HACHUREG", 
  "HACHUREV", "HACHUREH", "HACHURET", "HACHURES", "OVERWRITE", "SIZE", 
  "ROTATION", "NROTATION", "REVERT", "IGNORE", "LONGSIGN", "WIDECADRAT", 
  "TEXTESUPER", "POINTROUGE", "POINTNOIR", "RED", "BLACK", "HAPLOGRAPHIE", 
  "LACUNE", "LIGNELACUNE", "DSTSUPERFETATOIRE", "FSTSUPERFETATOIRE", 
  "DSTEFFACE", "FSTEFFACE", "DSTDISPARU", "FSTDISPARU", "DSTRAJOUTSCRIBE", 
  "FSTRAJOUTSCRIBE", "DSTRAJOUTAUTEUR", "FSTRAJOUTAUTEUR", "SEPARATEUR", 
  "FINMOT", "GRAMMAIRE", "FIN_LIGNE", "FIN_PAGE", "SAUT_LIGNES", 
  "SAUT_PAGES", "FIXE_LIGNE", "LIGNE_COMMENTAIRE", "':'", "'*'", "'&'", 
  "'['", "']'", "'('", "')'", "hierogs", "startinggarbage", "textes", 
  "textitem", "separation", "texteseps", "textesep", "texte", 
  "hachureopt", "uppercadrat", "embeddedQuadras", "quadras", "separateur", 
  "quadra", "lonesign", "sousquadras", "options", "sousquadra", 
  "sousquadraAux", "inhierliste", "kerning", "hieroglyphes", 
  "suiteligature", "signe", "hieroglyphe", "grammaireopt", "finmotopt", 
  "modificateurs", "modificateur", "construction_parenthesee", 0
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives. */
static const short yyr1[] =
{
       0,    67,    67,    67,    68,    68,    69,    69,    70,    71,
      72,    72,    73,    73,    73,    74,    74,    74,    74,    74,
      75,    75,    76,    77,    78,    78,    79,    79,    80,    80,
      81,    81,    81,    81,    81,    81,    81,    82,    82,    83,
      83,    84,    85,    85,    86,    86,    86,    86,    86,    86,
      87,    87,    88,    88,    89,    89,    90,    90,    90,    90,
      90,    90,    91,    91,    91,    91,    91,    92,    92,    93,
      93,    94,    94,    95,    95,    95,    95,    95,    95,    96,
      96,    96,    96,    96
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN. */
static const short yyr2[] =
{
       0,     3,     1,     1,     1,     2,     1,     3,     2,     2,
       0,     2,     1,     1,     1,     2,     1,     1,     1,     1,
       1,     0,     4,     2,     1,     2,     0,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     5,     0,
       2,     1,     5,     1,     1,     3,     4,     3,     1,     3,
       0,     2,     1,     3,     1,     3,     1,     1,     1,     1,
       1,     1,     5,     1,     1,     1,     1,     1,     0,     1,
       0,     0,     2,     1,     1,     1,     1,     1,     1,     3,
       3,     3,     3,     3
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error. */
static const short yydefact[] =
{
       0,     3,    27,    26,    50,     4,    10,     5,    26,     6,
      68,     9,    50,    51,    26,    30,    32,    33,    26,    63,
      65,    64,    66,    36,    31,    34,    35,    26,    26,    26,
      26,    26,    67,    17,    16,    18,    19,    26,     8,    21,
      29,    28,    37,    41,    43,    44,    52,     0,    48,    12,
      13,    14,    11,     7,    50,    24,     0,    26,     0,     0,
       0,     0,     0,     0,     0,    20,    15,    39,    39,    68,
      68,    56,    61,    57,    58,    59,    60,    71,    68,    39,
      50,    25,    47,    79,    80,    81,    82,    83,    49,     0,
      50,    50,    54,    45,    53,    73,    74,    75,    76,    77,
      78,    39,    71,    21,    46,    40,    68,    68,    68,    70,
      72,    22,    38,    42,    55,    69,    62,     0,     0,     0
};

static const short yydefgoto[] =
{
     117,     4,     8,     9,    54,    11,    52,    38,    66,    55,
      56,    57,     6,    39,    40,    41,    90,    42,    43,    44,
      10,    45,    93,    77,    46,    47,   116,   101,   102,    48
};

static const short yypact[] =
{
       0,-32768,-32768,   -47,-32768,     5,-32768,-32768,   -47,-32768,
      46,   -11,    12,-32768,   -47,-32768,-32768,-32768,   -47,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,   -47,   -47,   -47,
     -47,   -47,-32768,-32768,-32768,-32768,-32768,   -47,-32768,    -5,
  -32768,   -31,-32768,   -30,-32768,   -32,    19,   154,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,    36,   -47,    53,    21,
      27,    34,    40,    42,    28,-32768,-32768,    33,    33,    99,
      99,-32768,-32768,-32768,-32768,-32768,-32768,    47,    92,    33,
     126,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,    26,
  -32768,-32768,    35,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,    33,    47,    -5,-32768,-32768,   106,   106,    99,    57,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,    98,   118,-32768
};

static const short yypgoto[] =
{
  -32768,-32768,-32768,   111,    24,-32768,-32768,-32768,    31,    79,
     166,-32768,-32768,    62,-32768,-32768,   -51,    38,-32768,    39,
      -8,   -66,    48,-32768,    72,-32768,-32768,    52,-32768,-32768
};


#define	YYLAST		203


static const short yytable[] =
{
     -26,     1,    49,    92,     2,    -2,   -26,   -26,   -26,   -26,
     -26,   -26,    -1,   -26,   -26,   -26,   -26,    91,   -26,    65,
     -26,   -26,   -26,   -26,     5,    50,    51,     7,   104,    67,
      69,    68,    12,   -26,   -26,   -26,   -26,   -26,   -26,   -26,
     -26,   -26,    92,   -26,    70,   -26,    78,   -26,    79,   -26,
     109,     2,     3,   -26,   -26,   -26,    13,    14,   -26,   -26,
      15,    16,    17,    83,    18,   -26,    19,    20,    21,    22,
      82,    84,    78,    95,    96,    97,    98,    99,   100,    23,
      85,    80,   106,   107,    24,    25,    26,    27,    86,    28,
     105,    29,    87,    30,    88,    31,    89,   108,   118,    32,
      33,    34,    13,    14,    35,    36,    15,    16,    17,   115,
      18,    37,    19,    20,    21,    22,    13,    14,   119,    19,
      20,    21,    22,    53,    18,    23,    19,    20,    21,    22,
      24,    25,    26,    27,   111,    28,    81,    29,   -23,    30,
     103,    31,    94,   -23,   112,    32,   113,    27,     0,    28,
       0,    29,    32,    30,   110,    31,   114,    37,     0,    32,
      71,    72,    73,    74,     0,     0,     0,     0,   -23,     0,
     -23,    37,   -23,     0,   -23,     0,   -23,     0,     0,     0,
       0,     0,     0,     0,    58,     0,     0,     0,    75,    76,
       0,     0,   -23,    59,    60,    61,    62,    63,     0,     0,
       0,     0,     0,    64
};

static const short yycheck[] =
{
       0,     1,    13,    69,    51,     0,     6,     7,     8,     9,
      10,    11,     0,    13,    14,    15,    16,    68,    18,    24,
      20,    21,    22,    23,     0,    36,    37,     3,    79,    60,
      62,    61,     8,    33,    34,    35,    36,    37,    38,    39,
      40,    41,   108,    43,    25,    45,    54,    47,    12,    49,
     101,    51,    52,    53,    54,    55,    10,    11,    58,    59,
      14,    15,    16,    42,    18,    65,    20,    21,    22,    23,
      17,    44,    80,    26,    27,    28,    29,    30,    31,    33,
      46,    57,    90,    91,    38,    39,    40,    41,    48,    43,
      64,    45,    50,    47,    66,    49,    63,    62,     0,    53,
      54,    55,    10,    11,    58,    59,    14,    15,    16,    52,
      18,    65,    20,    21,    22,    23,    10,    11,     0,    20,
      21,    22,    23,    12,    18,    33,    20,    21,    22,    23,
      38,    39,    40,    41,   103,    43,    57,    45,    12,    47,
      78,    49,    70,    17,   106,    53,   107,    41,    -1,    43,
      -1,    45,    53,    47,   102,    49,   108,    65,    -1,    53,
       6,     7,     8,     9,    -1,    -1,    -1,    -1,    42,    -1,
      44,    65,    46,    -1,    48,    -1,    50,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    18,    -1,    -1,    -1,    34,    35,
      -1,    -1,    66,    27,    28,    29,    30,    31,    -1,    -1,
      -1,    -1,    -1,    37
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison/bison.simple"

/* Skeleton output parser for bison,

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software
   Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser when
   the %semantic_parser declaration is not specified in the grammar.
   It was written by Richard Stallman by simplifying the hairy parser
   used when %semantic_parser is specified.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

#if ! defined (yyoverflow) || defined (YYERROR_VERBOSE)

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || defined (YYERROR_VERBOSE) */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYLTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
# if YYLSP_NEEDED
  YYLTYPE yyls;
# endif
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# if YYLSP_NEEDED
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE) + sizeof (YYLTYPE))	\
      + 2 * YYSTACK_GAP_MAX)
# else
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)
# endif

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif


#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).

   When YYLLOC_DEFAULT is run, CURRENT is set the location of the
   first token.  By default, to implement support for ranges, extend
   its range to the last symbol.  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)       	\
   Current.last_line   = Rhs[N].last_line;	\
   Current.last_column = Rhs[N].last_column;
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#if YYPURE
# if YYLSP_NEEDED
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, &yylloc, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval, &yylloc)
#  endif
# else /* !YYLSP_NEEDED */
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval)
#  endif
# endif /* !YYLSP_NEEDED */
#else /* !YYPURE */
# define YYLEX			yylex ()
#endif /* !YYPURE */


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

#ifdef YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif
#endif

#line 315 "/usr/share/bison/bison.simple"


/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif

/* YY_DECL_VARIABLES -- depending whether we use a pure parser,
   variables are global, or local to YYPARSE.  */

#define YY_DECL_NON_LSP_VARIABLES			\
/* The lookahead symbol.  */				\
int yychar;						\
							\
/* The semantic value of the lookahead symbol. */	\
YYSTYPE yylval;						\
							\
/* Number of parse errors so far.  */			\
int yynerrs;

#if YYLSP_NEEDED
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES			\
						\
/* Location data for the lookahead symbol.  */	\
YYLTYPE yylloc;
#else
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES
#endif


/* If nonreentrant, generate the variables here. */

#if !YYPURE
YY_DECL_VARIABLES
#endif  /* !YYPURE */

int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  /* If reentrant, generate the variables here. */
#if YYPURE
  YY_DECL_VARIABLES
#endif  /* !YYPURE */

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack. */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;

#if YYLSP_NEEDED
  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
#endif

#if YYLSP_NEEDED
# define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
# define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  YYSIZE_T yystacksize = YYINITDEPTH;


  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
#if YYLSP_NEEDED
  YYLTYPE yyloc;
#endif

  /* When reducing, the number of symbols on the RHS of the reduced
     rule. */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
#if YYLSP_NEEDED
  yylsp = yyls;
#endif
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  */
# if YYLSP_NEEDED
	YYLTYPE *yyls1 = yyls;
	/* This used to be a conditional around just the two extra args,
	   but that might be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
# else
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);
# endif
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
# if YYLSP_NEEDED
	YYSTACK_RELOCATE (yyls);
# endif
# undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
#if YYLSP_NEEDED
      yylsp = yyls + yysize - 1;
#endif

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

#if YYDEBUG
     /* We have to keep this `#if YYDEBUG', since we use variables
	which are defined only if `YYDEBUG' is set.  */
      if (yydebug)
	{
	  YYFPRINTF (stderr, "Next token is %d (%s",
		     yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise
	     meaning of a token, for further debugging info.  */
# ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
# endif
	  YYFPRINTF (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to the semantic value of
     the lookahead token.  This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

#if YYLSP_NEEDED
  /* Similarly for the default location.  Let the user run additional
     commands if for instance locations are ranges.  */
  yyloc = yylsp[1-yylen];
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
#endif

#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] > 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif

  switch (yyn) {

case 1:
#line 126 "./sesh.y"
{
	resultat = yyvsp[-1].une_texte_liste.texte;
}
    break;
case 2:
#line 129 "./sesh.y"
{resultat= NULL;}
    break;
case 3:
#line 130 "./sesh.y"
{resultat= NULL;}
    break;
case 5:
#line 135 "./sesh.y"
{yyval.un_separateur=yyvsp[0].un_separateur;}
    break;
case 6:
#line 139 "./sesh.y"
{
	yyval.une_texte_liste.texte= yyvsp[0].une_texte_liste.texte;
	yyval.une_texte_liste.last=  yyvsp[0].une_texte_liste.last;
	/* kerning ignor */
}
    break;
case 7:
#line 145 "./sesh.y"
{
	yyval.une_texte_liste.texte=yyvsp[-2].une_texte_liste.texte;
	yyval.une_texte_liste.last->next= yyvsp[0].une_texte_liste.texte;
	yyvsp[0].une_texte_liste.texte->previous= yyval.une_texte_liste.last;
	yyval.une_texte_liste.last=yyvsp[0].une_texte_liste.last;
}
    break;
case 8:
#line 154 "./sesh.y"
{
	yyval.une_texte_liste.texte= yyvsp[0].un_texte;
	yyval.une_texte_liste.last= yyvsp[0].un_texte;
	if (ingray)
		SET_GRIS(yyvsp[0].un_texte);
	if (color == 1)
		yyvsp[0].un_texte->couleur= red;
}
    break;
case 10:
#line 168 "./sesh.y"
{yyval.un_entier=0;}
    break;
case 12:
#line 173 "./sesh.y"
{
	ingray= 1-ingray;
	yyval.un_entier= 0;
}
    break;
case 13:
#line 177 "./sesh.y"
{
	color= 1;
	yyval.un_entier=0;
}
    break;
case 14:
#line 181 "./sesh.y"
{
	color= 0;
	yyval.un_entier=0;
}
    break;
case 15:
#line 189 "./sesh.y"
{
	yyval.un_texte= NewTexte();
	yyval.un_texte->q= yyvsp[-1].un_quadra;
	SESH_creer_listesignes(yyvsp[-1].un_quadra, &(yyval.un_texte->lessignes));
	yyval.un_texte->q->hachures= yyvsp[0].des_hachures;
}
    break;
case 16:
#line 196 "./sesh.y"
{
	yyval.un_texte= NewTexte();	
	yyval.un_texte->type= T_NP;
	yyval.un_texte->saut= 0;
}
    break;
case 17:
#line 202 "./sesh.y"
{
	yyval.un_texte= NewTexte();	
	yyval.un_texte->type= T_NL;
	yyval.un_texte->saut= 0;
}
    break;
case 18:
#line 208 "./sesh.y"
{
	yyval.un_texte= NewTexte();	
	yyval.un_texte->type= T_FIXE_COORDONNEES;
	yyval.un_texte->coordonnees= yyvsp[0].des_coordonnees;
}
    break;
case 19:
#line 214 "./sesh.y"
{
	yyval.un_texte= NewTexte();
	yyval.un_texte->type= T_LIGNE_COMMENTAIRE;
	yyval.un_texte->texte= yyvsp[0].une_chaine; 
}
    break;
case 20:
#line 222 "./sesh.y"
{yyval.des_hachures= yyvsp[0].des_hachures;}
    break;
case 21:
#line 223 "./sesh.y"
{yyval.des_hachures= NOHACHURE;}
    break;
case 22:
#line 227 "./sesh.y"
{
	yyval.un_quadra= yyvsp[-1].un_quadra;
	yyval.un_quadra->hachures= yyvsp[0].des_hachures;
	if (ingray)
		yyval.un_quadra->est_grise= TRUE;
	yyval.un_quadra->kerning= yyvsp[-2].un_entier;								/* nombre de signes de kerning */
	yyval.un_quadra->separateur= yyvsp[-3].un_separateur;	
}
    break;
case 23:
#line 238 "./sesh.y"
{
	yyval.un_quadra= yyvsp[-1].un_quadra;
}
    break;
case 24:
#line 244 "./sesh.y"
{
	yyval.un_quadra= yyvsp[0].un_quadra;
}
    break;
case 25:
#line 248 "./sesh.y"
{
	yyval.un_quadra=yyvsp[-1].un_quadra;
	yyval.un_quadra->last->next= yyvsp[0].un_quadra;
	yyvsp[0].un_quadra->previous= yyval.un_quadra->last;
	yyval.un_quadra->last=yyvsp[0].un_quadra;
}
    break;
case 26:
#line 257 "./sesh.y"
{ yyval.un_separateur= S_intersignes; }
    break;
case 28:
#line 262 "./sesh.y"
{
	if (S_NEXT_OF(*(yyvsp[0].une_vertlist)) == NULL
			&& S_NEXT_OF(*VL_QUADRA_OF(*(yyvsp[0].une_vertlist))) == NULL
			&& (S_TYPE_OF(*VL_QUADRA_OF(*(yyvsp[0].une_vertlist))) != S_quadra
					&&
					S_TYPE_OF(*VL_QUADRA_OF(*(yyvsp[0].une_vertlist))) != S_signe))
	{															
		/* suppression des informations superflues */
		yyval.un_quadra= VL_QUADRA_OF(*(yyvsp[0].une_vertlist));
		VL_QUADRA_OF(*(yyvsp[0].une_vertlist))= NULL;
		detruit_vertlist(yyvsp[0].une_vertlist);
 	}
	else
	{
		yyval.un_quadra= new_quadra(S_quadra);
		yyval.un_quadra->kerning= 0;
		yyval.un_quadra->contenu.horizontal= yyvsp[0].une_vertlist;
	}
}
    break;
case 29:
#line 282 "./sesh.y"
{
	yyval.un_quadra= new_quadra(S_signe);
	yyval.un_quadra->contenu.un_signe= yyvsp[0].signe;
}
    break;
case 30:
#line 289 "./sesh.y"
{
	yyval.signe= new_sign(S_romain);
	yyval.signe->donnees= yyvsp[0].une_donnee;
}
    break;
case 31:
#line 294 "./sesh.y"
{
	yyval.signe= new_sign(S_haplographie);
}
    break;
case 32:
#line 298 "./sesh.y"
{
	yyval.signe= new_sign(S_gauchedroite);
}
    break;
case 33:
#line 302 "./sesh.y"
{
	yyval.signe= new_sign(S_droitegauche);
}
    break;
case 34:
#line 306 "./sesh.y"
{
	yyval.signe= new_sign(S_lacune);
}
    break;
case 35:
#line 310 "./sesh.y"
{
	 yyval.signe= new_sign(S_lignelacune);
 }
    break;
case 36:
#line 314 "./sesh.y"
{
	 yyval.signe= new_sign(S_textesuper);
	 yyval.signe->donnees= yyvsp[0].une_donnee;
 }
    break;
case 37:
#line 321 "./sesh.y"
{
	 yyval.une_vertlist= new_vert();
	 yyval.une_vertlist->un_quadra= yyvsp[0].un_quadra;
 }
    break;
case 38:
#line 326 "./sesh.y"
{
	 yyval.une_vertlist=yyvsp[-4].une_vertlist;
	 yyval.une_vertlist->last->next= new_vert();
	 yyval.une_vertlist->last->next->previous= yyval.une_vertlist->last;
	 yyval.une_vertlist->last= yyval.une_vertlist->last->next;
	 yyval.une_vertlist->last->un_quadra= yyvsp[0].un_quadra;
	 yyval.une_vertlist->last->kerning= yyvsp[-1].un_entier;
	 /* False, but just to try */
	 yyval.une_vertlist->last->kerning= yyvsp[-2].un_entier;
 }
    break;
case 39:
#line 342 "./sesh.y"
{yyval.un_entier=0;}
    break;
case 40:
#line 343 "./sesh.y"
{yyval.un_entier=1;}
    break;
case 41:
#line 346 "./sesh.y"
{yyval.un_quadra= yyvsp[0].un_quadra;}
    break;
case 42:
#line 349 "./sesh.y"
{
	 yyval.un_quadra= yyvsp[-4].un_quadra;
	 yyval.un_quadra->last->next= yyvsp[0].un_quadra;
	 yyval.un_quadra->last->separateur= S_intersignes;
	 yyval.un_quadra->last->next->previous= yyval.un_quadra->last;
	 yyval.un_quadra->last= yyvsp[0].un_quadra;
	 yyval.un_quadra->last->kerning= yyvsp[-1].un_entier;
 }
    break;
case 43:
#line 358 "./sesh.y"
{
	 yyval.un_quadra= yyvsp[0].un_quadra;
 }
    break;
case 44:
#line 365 "./sesh.y"
{
	yyval.un_quadra= new_quadra(S_signe);
	yyval.un_quadra->contenu.un_signe= yyvsp[0].signe;
}
    break;
case 45:
#line 370 "./sesh.y"
{
	yyval.un_quadra= new_quadra(S_ligature);
	yyval.un_quadra->contenu.lig= new_liggroup();
	yyval.un_quadra->contenu.lig->l= NULL;
	yyval.un_quadra->contenu.lig->nbr= 1 + yyvsp[0].ligature->nbr;
	yyval.un_quadra->contenu.lig->signs= new_signinlig();
	yyval.un_quadra->contenu.lig->signs->nbr= 1;
	yyval.un_quadra->contenu.lig->signs->sign= yyvsp[-2].signe;
	yyval.un_quadra->contenu.lig->signs->next= yyvsp[0].ligature;
	fix_ligature(yyval.un_quadra->contenu.lig);
}
    break;
case 46:
#line 382 "./sesh.y"
{	
	yyval.un_quadra= new_quadra(yyvsp[-3].un_typegroupe);
	yyval.un_quadra->contenu.des_quadras= yyvsp[-2].un_quadra;
	yyval.un_quadra->kerning= 0;	
}
    break;
case 47:
#line 388 "./sesh.y"
{	
	yyval.un_quadra= new_quadra(S_rightleft);
	yyval.un_quadra->contenu.des_quadras= yyvsp[-1].un_quadra;
	yyval.un_quadra->kerning= 0;	
}
    break;
case 49:
#line 395 "./sesh.y"
{
	yyval.un_quadra= yyvsp[-1].un_quadra;
}
    break;
case 50:
#line 402 "./sesh.y"
{
	yyval.un_entier =0;
}
    break;
case 51:
#line 406 "./sesh.y"
{
	yyval.un_entier= yyvsp[-1].un_entier + 1;
}
    break;
case 53:
#line 413 "./sesh.y"
{
	yyval.signe= new_sign(S_overwrite);
	yyval.signe->donnees.over[0]= yyvsp[-2].signe;
	yyval.signe->donnees.over[1]= yyvsp[0].signe;
}
    break;
case 54:
#line 422 "./sesh.y"
{
	yyval.ligature= new_signinlig();
	yyval.ligature->nbr= 1;
	yyval.ligature->sign= yyvsp[0].signe;
	yyval.ligature->next= NULL;
}
    break;
case 55:
#line 429 "./sesh.y"
{
	yyval.ligature= new_signinlig();
	yyval.ligature->nbr= 1 + yyvsp[0].ligature->nbr;
	yyval.ligature->sign= yyvsp[-2].signe;
	yyval.ligature->next= yyvsp[0].ligature;	
}
    break;
case 56:
#line 439 "./sesh.y"
{
	yyval.signe= new_sign(S_hieroglyphe);
	yyval.signe->donnees= yyvsp[0].une_donnee;
}
    break;
case 57:
#line 444 "./sesh.y"
{
	 yyval.signe= new_sign(S_point);
 }
    break;
case 58:
#line 448 "./sesh.y"
{
	yyval.signe= new_sign(S_pointpoint);
}
    break;
case 59:
#line 452 "./sesh.y"
{
	yyval.signe= new_sign(S_pointrouge);
	yyval.signe->donnees= yyvsp[0].une_donnee;
}
    break;
case 60:
#line 457 "./sesh.y"
{
	yyval.signe= new_sign(S_pointnoir);
	yyval.signe->donnees= yyvsp[0].une_donnee;
}
    break;
case 61:
#line 462 "./sesh.y"
{
	yyval.signe= new_sign(S_inconnu);
	yyval.signe->donnees= yyvsp[0].une_donnee;	
}
    break;
case 62:
#line 469 "./sesh.y"
{
	yyval.signe= yyvsp[-3].signe;
	yyval.signe->estfinmot= yyvsp[0].un_entier;
	yyval.signe->estgram= yyvsp[-4].un_entier;	
}
    break;
case 63:
#line 474 "./sesh.y"
{
	 yyval.signe= new_sign(S_hachureg);
	 yyval.signe->type= S_hachureg;
 }
    break;
case 64:
#line 479 "./sesh.y"
{
	 yyval.signe= new_sign(S_hachureh);
}
    break;
case 65:
#line 483 "./sesh.y"
{
	yyval.signe= new_sign(S_hachurev);
}
    break;
case 66:
#line 487 "./sesh.y"
{
	yyval.signe= new_sign(S_hachuret);
}
    break;
case 67:
#line 492 "./sesh.y"
{yyval.un_entier= TRUE;}
    break;
case 68:
#line 493 "./sesh.y"
{yyval.un_entier= FALSE;}
    break;
case 69:
#line 496 "./sesh.y"
{yyval.un_entier= TRUE;}
    break;
case 70:
#line 497 "./sesh.y"
{yyval.un_entier= FALSE;}
    break;
case 71:
#line 500 "./sesh.y"
{yyval.signe = yyvsp[0].signe;}
    break;
case 72:
#line 501 "./sesh.y"
{yyval.signe = yyvsp[-2].signe;}
    break;
case 73:
#line 505 "./sesh.y"
{yyval.signe = yyvsp[-1].signe; 	yyval.signe->size= yyvsp[0].un_entier;}
    break;
case 74:
#line 506 "./sesh.y"
{yyval.signe = yyvsp[-1].signe; yyval.signe->rotation= yyvsp[0].un_entier;}
    break;
case 75:
#line 507 "./sesh.y"
{yyval.signe = yyvsp[-1].signe; yyval.signe->rotation= yyvsp[0].un_entier; yyval.signe->revert= TRUE;}
    break;
case 76:
#line 508 "./sesh.y"
{yyval.signe = yyvsp[-1].signe; 
						yyval.signe->revert= TRUE;}
    break;
case 77:
#line 510 "./sesh.y"
{yyval.signe = yyvsp[-1].signe; yyval.signe->ignore= TRUE;}
    break;
case 78:
#line 511 "./sesh.y"
{yyval.signe = yyvsp[-1].signe; yyval.signe->islong= yyvsp[0].un_entier;}
    break;
case 79:
#line 516 "./sesh.y"
{
	yyval.un_quadra= new_quadra(S_superfetatoire);						
	yyval.un_quadra->contenu.des_quadras= yyvsp[-1].un_quadra;
	yyval.un_quadra->kerning= 0;	
}
    break;
case 80:
#line 522 "./sesh.y"
{
	yyval.un_quadra= new_quadra(S_efface);						
	yyval.un_quadra->contenu.des_quadras= yyvsp[-1].un_quadra;
	yyval.un_quadra->kerning= 0;
}
    break;
case 81:
#line 528 "./sesh.y"
{
	yyval.un_quadra= new_quadra(S_disparu);						
	yyval.un_quadra->contenu.des_quadras= yyvsp[-1].un_quadra;
	yyval.un_quadra->kerning= 0;
}
    break;
case 82:
#line 534 "./sesh.y"
{
	yyval.un_quadra= new_quadra(S_ajoutscribe);
	yyval.un_quadra->contenu.des_quadras= yyvsp[-1].un_quadra;
	yyval.un_quadra->kerning= 0;
}
    break;
case 83:
#line 540 "./sesh.y"
{
	yyval.un_quadra= new_quadra(S_ajoutauteur);						
	yyval.un_quadra->contenu.des_quadras= yyvsp[-1].un_quadra;
	yyval.un_quadra->kerning= 0;
}
    break;
}

#line 705 "/usr/share/bison/bison.simple"


  yyvsp -= yylen;
  yyssp -= yylen;
#if YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;
#if YYLSP_NEEDED
  *++yylsp = yyloc;
#endif

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[YYTRANSLATE (yychar)]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[YYTRANSLATE (yychar)]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* defined (YYERROR_VERBOSE) */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*--------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action |
`--------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;
      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;


/*-------------------------------------------------------------------.
| yyerrdefault -- current state does not do anything special for the |
| error token.                                                       |
`-------------------------------------------------------------------*/
yyerrdefault:
#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */

  /* If its default is to accept any token, ok.  Otherwise pop it.  */
  yyn = yydefact[yystate];
  if (yyn)
    goto yydefault;
#endif


/*---------------------------------------------------------------.
| yyerrpop -- pop the current state because it cannot handle the |
| error token                                                    |
`---------------------------------------------------------------*/
yyerrpop:
  if (yyssp == yyss)
    YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#if YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "Error: state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

/*--------------.
| yyerrhandle.  |
`--------------*/
yyerrhandle:
  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

/*---------------------------------------------.
| yyoverflowab -- parser overflow comes here.  |
`---------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}
#line 547 "./sesh.y"



/**
 *
 */

PUBLIC Texte *
sesh_parse_array(char *array)
{
	extern int seshnumligne;
	extern void SESH_init_seshlex();
	resultat= NULL;
	erreur_de_syntaxe= 0;
	seshnumligne= 0;
	color= 0;
	ingray= FALSE;
	init_array_read(array);
	SESH_init_seshlex();
	yyparse();
	return resultat;
}

/**
	Used for error messages
 */

PUBLIC void 
sesherror(char *s)
{
		extern char *seshtext;
		extern int seshnumligne;
		erreur_de_syntaxe= 1;
		sprintf(rapport_erreur_de_syntaxe, "%s, pres de %s ligne %d\n", s, 
						seshtext, seshnumligne);
}

/*
 * Local Variables:
 * header: "seshaux.h"
 * tab-width: 2
 * End:
 */
