
#include "tks_geometry.h"

void
TKSGeom_init(TKSTexteGeometry *geom)
{
  geom->natural_h= 17.0;
  geom->natural_w= 17.0 * 1.0;
  geom->maxh= 0.8;
  geom->maxw= 0.8;
  geom->smallskip= 2.0;
  geom->show_words= 0;
  geom->show_gram= 0;
  geom->vcenter= 0;
  geom->right_left= 0;
  geom->in_columns= 0;
}

double
TKSGeom_getNaturalHeight(TKSTexteGeometry *geom)
{
  return geom->natural_h;
}

double
TKSGeom_getNaturalWidth(TKSTexteGeometry *geom)
{
  return geom->natural_w;
}


double
TKSGeom_getMaxH(TKSTexteGeometry *geom)
{
  return geom->maxh;
}

double
TKSGeom_getMaxW(TKSTexteGeometry *geom)
{
  return geom->maxw;
}

double
TKSGeom_getSmallSkip(TKSTexteGeometry *geom)
{
  return geom->smallskip;
}

int
TKSGeom_getShowWords(TKSTexteGeometry *geom)
{
  return geom->show_words;
}

int
TKSGeom_getShowGram(TKSTexteGeometry *geom)
{
  return geom->show_gram;
}

void
TKSGeom_setCentered(TKSTexteGeometry *geom, int val)
{
  geom->vcenter= val;
}

int
TKSGeom_isCenteredP(TKSTexteGeometry *geom)
{
  return geom->vcenter;
}

int
TKSGeom_isRightLeftP(TKSTexteGeometry *geom)
{
  return geom->right_left;
}

int
TKSGeom_isInColumnsP(TKSTexteGeometry *geom)
{
  return geom->in_columns;
}

