
package provide glossary 0.0

package require TkseshDB

namespace eval Glossary {
    array set GLOSSARY {}
    
    proc db {} {
	return [TkseshDB::getTkseshDB]
    }

    proc isAGlossaryCode {code} {
	set code [TkseshDB::protectText $code]
	set l [TkseshDB::select [db] "select value from glossary where code = '$code'"]
	return [expr {[llength $l] != 0}]
    }

    proc getGlossaryEntry {code} {
	set code [TkseshDB::protectText $code]
	set l [TkseshDB::select [db] "select value from glossary where code = '$code'"]
	return [lindex $l 0]
    }

    proc setGlossaryEntry {code val} {
	set code [TkseshDB::protectText $code]
	set val [TkseshDB::protectText $val]
	TkseshDB::begin [db]
	TkseshDB::update [db] "delete from glossary where code = '$code'"
	TkseshDB::update [db] "insert into glossary values ('$code', '$val')"
	TkseshDB::commit [db]
    }

    proc listEntries {} {
	set l [TkseshDB::select [db] "select code from glossary"]
	return $l
    }
}
 