
#define _POSIX_SOURCE 1

/**********************************************************************
 *
 *          Initialisation et chargement du widget TKSESH
 *
 *********************************************************************/

/*  1998 Serge Rosmorduc,
 * quipe EC.art, Laboratoire LRIA, Universit de Paris 8
 *
 * 15 rue Catulienne
 * 93236 St Denis Cedex
 * FRANCE
 *
 * Tout droits rservs.
 * 
 * voyez le fichier ../LICENCE.txt pour plus d'informations
 * See the ../LICENCEE.txt file for more information
 *
 * $Id: tksinit.c,v 1.1.1.1 2002/04/16 13:55:00 rosmord Exp $
 *
 */

/*
 * $Log: tksinit.c,v $
 * Revision 1.1.1.1  2002/04/16 13:55:00  rosmord
 * Imported using tkCVS
 *
 * Revision 1.9  1999/10/04 16:10:58  rosmord
 * *** empty log message ***
 *
 */


#include <tcl.h>
#include <tk.h>

#include "general.h"
#include "tclsigns.h"

#include "tksesh.h"
#include "fordll.h"


EXTERN EXPORT(int,Tksesh_Init) _ANSI_ARGS_((Tcl_Interp *interp));


int
Tksesh_Init(Tcl_Interp *interp)
{
	SeshMyInit(interp);
	Tcl_CreateCommand(interp, "sesh", 
										SeshCmd,
										(ClientData) Tk_MainWindow(interp), 
										(Tcl_CmdDeleteProc *) NULL);
	TKSESH_Signs_Init(interp);
	return Tcl_PkgProvide(interp, "Tksesh", "1.0");
}
/*
 * Local Variables:
 * tab-width: 2
 * End:
 */
