lappend auto_path [file join [pwd] ..]
package require xml 
package require xpath
xml::parser pr
set parser pr


proc HandleText {data} {
    puts "Character data ==> $data"
}

proc mStart {name attlist args} {
    array set tmp $attlist
    puts "Element start ==> $name has attributes :"
    if {$name eq "path"} {
	set black [string match fill:\#000 $tmp(style)]
	parseSVGPath $tmp(d) $black
    }
    puts "arguments $args"
}

proc HandleEnd {name} {
    puts "Element end ==> end of $name"
}

proc testAttList {elt attr type def val} {
    puts "elt is $elt\nattr is $attr\n type is $type\ndefault is $def\nval is $val"
}

proc loadDTD {name public system dtd} {
    puts "$name, $public, $system, $dtd"
    
}

proc parseSVGPath {path color} {
    set p [string map {M " M " L " L " C " C " z " z"} $path]
    puts $p

}

$parser configure -characterdatacommand HandleText \
	-elementstartcommand mStart -doctypecommand loadDTD

#$parser configure -elementendcommand HandleEnd
$parser configure -attlistdeclcommand testAttList
$parser configure -defaultcommand puts
$parser configure -validate 1

set f [open A1.svg]
set t [read $f]
close $f

$parser parse $t

puts [xpath::split {svg/path[2]}]
