lappend auto_path [pwd]/..

puts $auto_path

package require stooop
namespace import stooop::*

package require tclSQLDB
#package require sqlite

# Test for writing cursors :

set db [new SQLDB "toto.db"]

if {1} {
    catch {SQLDB::update $db {drop table test}}
    SQLDB::update $db {create table test (i int PRIMARY KEY, j int)}
    for {set i 0} {$i < 1000} {incr i} {
	SQLDB::update $db "insert into test values ($i, [expr 2 * $i])"
	if {$i % 1000 == 0} {puts $i}
    }
}

#puts [sqldb eval {select * from (select i from test) limit 10 OFFSET 5090}]

set i [new DBIterator $db "select * from test" 128]

set n 0
for {} {$n < 410} {DBIterator::next $i; incr n} {
    puts "valeur : [DBIterator::getValue $i]"
}

for {} {[DBIterator::hasValue $i]} {DBIterator::previous $i} {
    puts "valeur : [DBIterator::getValue $i]"
}

delete $i
delete $db

