
source ./stooop/stooop.tcl
package require stooop
namespace import stooop::*


# In stooop 3.7, there's a maybe a bug. 
# Indirect inheritance doesn't work well.
# First, one has to repeat "virtual", but this is not grevious
# (the f used below is class B's f, not class C's)
# But more annoyingly, g redefinition doesn't work

class A {
    proc A {this} {}
    virtual proc b {this} {puts A}
    virtual proc f {this} {puts A}
    virtual proc g {this} {puts A}
    proc h {this} {
	b $this
	f $this
	g $this
    }
}

class B {
    proc B {this} A {} {
    }
    virtual proc b {this} {puts B}
    proc f {this} {puts B}
}

class C {
    proc C {this} B {} {
    }
    proc b {this} {puts c}
    proc f {this} {puts c}
    virtual proc g {this} {puts c}
}

set i [new C]
A::h $i


